# Class VulkanImageSubresourceRange.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanImageSubresourceRange.Builder

Enclosing class:
  `VulkanImageSubresourceRange`

public static final class VulkanImageSubresourceRange.Builder extends Object
Builds instances of type `VulkanImageSubresourceRange`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanImageSubresourceRange.Builder`
  `addAllAspectMask(Iterable<VulkanImageAspectFlag> elements)`
  Adds elements to `aspectMask` set.
  `final VulkanImageSubresourceRange.Builder`
  `addAspectMask(VulkanImageAspectFlag element)`
  Adds one element to `aspectMask` set.
  `final VulkanImageSubresourceRange.Builder`
  `addAspectMask(VulkanImageAspectFlag... elements)`
  Adds elements to `aspectMask` set.
  `VulkanImageSubresourceRange`
  `build()`
  Builds a new `VulkanImageSubresourceRange`.
  `final VulkanImageSubresourceRange.Builder`
  `from(VulkanImageSubresourceRangeType instance)`
  Fill a builder with attribute values from the provided `VulkanImageSubresourceRangeType` instance.
  `final VulkanImageSubresourceRange.Builder`
  `setAspectMask(Iterable<VulkanImageAspectFlag> elements)`
  Sets or replaces all elements for `aspectMask` set.
  `final VulkanImageSubresourceRange.Builder`
  `setBaseArrayLayer(int baseArrayLayer)`
  Initializes the value for the `baseArrayLayer` attribute.
  `final VulkanImageSubresourceRange.Builder`
  `setBaseMipLevel(int baseMipLevel)`
  Initializes the value for the `baseMipLevel` attribute.
  `final VulkanImageSubresourceRange.Builder`
  `setLayerCount(int layerCount)`
  Initializes the value for the `layerCount` attribute.
  `final VulkanImageSubresourceRange.Builder`
  `setLevelCount(int levelCount)`
  Initializes the value for the `levelCount` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanImageSubresourceRange.Builder from(VulkanImageSubresourceRangeType instance)
    Fill a builder with attribute values from the provided `VulkanImageSubresourceRangeType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addAspectMask

    public final VulkanImageSubresourceRange.Builder addAspectMask(VulkanImageAspectFlag element)
    Adds one element to `aspectMask` set.
    Parameters:
      `element` - A aspectMask element
    Returns:
      `this` builder for use in a chained invocation

  - ### addAspectMask

    public final VulkanImageSubresourceRange.Builder addAspectMask(VulkanImageAspectFlag... elements)
    Adds elements to `aspectMask` set.
    Parameters:
      `elements` - An array of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setAspectMask

    public final VulkanImageSubresourceRange.Builder setAspectMask(Iterable<VulkanImageAspectFlag> elements)
    Sets or replaces all elements for `aspectMask` set.
    Parameters:
      `elements` - An iterable of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllAspectMask

    public final VulkanImageSubresourceRange.Builder addAllAspectMask(Iterable<VulkanImageAspectFlag> elements)
    Adds elements to `aspectMask` set.
    Parameters:
      `elements` - An iterable of aspectMask elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setBaseMipLevel

    public final VulkanImageSubresourceRange.Builder setBaseMipLevel(int baseMipLevel)
    Initializes the value for the `baseMipLevel` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `baseMipLevel`.

    Parameters:
      `baseMipLevel` - The value for baseMipLevel
    Returns:
      `this` builder for use in a chained invocation

  - ### setLevelCount

    public final VulkanImageSubresourceRange.Builder setLevelCount(int levelCount)
    Initializes the value for the `levelCount` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `levelCount`.

    Parameters:
      `levelCount` - The value for levelCount
    Returns:
      `this` builder for use in a chained invocation

  - ### setBaseArrayLayer

    public final VulkanImageSubresourceRange.Builder setBaseArrayLayer(int baseArrayLayer)
    Initializes the value for the `baseArrayLayer` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `baseArrayLayer`.

    Parameters:
      `baseArrayLayer` - The value for baseArrayLayer
    Returns:
      `this` builder for use in a chained invocation

  - ### setLayerCount

    public final VulkanImageSubresourceRange.Builder setLayerCount(int layerCount)
    Initializes the value for the `layerCount` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `layerCount`.

    Parameters:
      `layerCount` - The value for layerCount
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanImageSubresourceRange build()
    Builds a new `VulkanImageSubresourceRange`.
    Returns:
      An immutable instance of VulkanImageSubresourceRange
    Throws:
      `IllegalStateException` - if any required attributes are missing